Bug 1566444 - crash in connection table / nunc-stans ?
Summary: crash in connection table / nunc-stans ?
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: 389-ds-base
Version: 7.4
Hardware: Unspecified
OS: Unspecified
unspecified
urgent
Target Milestone: rc
: ---
Assignee: thierry bordaz
QA Contact: RHDS QE
Marc Muehlfeld
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-04-12 10:40 UTC by German Parente
Modified: 2018-10-30 10:14 UTC (History)
7 users (show)

Fixed In Version: 389-ds-base-1.3.8.4-1.el7
Doc Type: Bug Fix
Doc Text:
Directory Server no longer crashes when removing connections from an active list Directory Server manages established connections in an active list. When a thread flags a connection for closing, the server waits until there are no active threads left on the connection to remove the connection from the active list. In certain situations, the number of active threads is less than the actual number of threads. In this scenario, Directory Server moves the connection out of the active list and flags it as invalid. Another remaining thread which detects that the connection is invalid also attempts to remove it from the active list. However, the code that removes the connection from the active list expects that the connection has valid list pointers. If the pointers are invalid because the connection is not on the active list, Directory Server terminates unexpectedly. With this update, the server checks that the list pointers are valid before using them. As a result, the server no longer crashes when attempting to remove a connection from the active list.
Clone Of:
Environment:
Last Closed: 2018-10-30 10:13:34 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:3127 None None None 2018-10-30 10:14:08 UTC

Description German Parente 2018-04-12 10:40:00 UTC
Description of problem:

customer is having repeatedly this crash after update to release 28.

"connection_table_move_connection_out_of_active_list"
"ns_handle_closure_nomutex"
"ns_handle_pr_read_ready"
"work_job_execute"
"event_cb"
"event_base_loop"
"ns_event_fw_loop"
"event_loop_thread_func"
"start_thread"
"__clone"

it was happening from time to time. Today the server is crashing non-stop showing this messages:

Apr 12 11:35:25 <xxxx> systemd: Started 389 Directory Server xx..
Apr 12 11:36:06 <xxxx> ns-slapd: *** stack smashing detected ***: /usr/sbin/ns-slapd terminated
Apr 12 11:36:06 <xxxx> kernel: traps: ns-slapd[5646] general protection ip:7f348ea15118 sp:7f343b6fcef0 error:0 in libgcc_s-4.8.5-20150702.so.1[7f348ea06000+15000]
Apr 12 11:36:06 <xxxx> systemd: dirsrv@bv.service: main process exited, code=killed, status=11/SEGV


Version-Release number of selected component (if applicable): 389-ds-base-1.3.6.1-28

I was told it's duplicated of 1517383 ns-slapd segfaults with ERR - connection_release_nolock_ext - conn=0 fd=0 Attempt to release connection that is not acquired

but I prefer to report a new bug with high priority.

I will add more information about the crashes of today.

Comment 19 Viktor Ashirov 2018-08-30 13:33:33 UTC
Build tested: 389-ds-base-1.3.8.4-12.el7.x86_64

I haven't encountered crash in connection_table_move_connection_out_of_active_list with NS enabled (it's disabled by default) in our acceptance testing, hence marking as VERIFIED, SanityOnly.

Comment 21 errata-xmlrpc 2018-10-30 10:13:34 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:3127


Note You need to log in before you can comment on or make changes to this bug.